#include <iostream>
#include <string>
#include <queue>
#include <algorithm>
#include <vector>

using namespace std;

struct Pismo {
	string nazivPrimatelja, adresaPrimatelja;
	int prioritet;

	Pismo(string nazivPrimatelja, string adresaPrimatelja, int prioritet) {
		this->nazivPrimatelja = nazivPrimatelja;
		this->adresaPrimatelja = adresaPrimatelja;
		this->prioritet = prioritet;
	}

	void print() {
		cout << "Naziv primatelja: " << nazivPrimatelja << endl;
		cout << "Adresa primatelja: " << adresaPrimatelja << endl;
		cout << "Prioritet: " << prioritet << endl;
	}
};

struct LetterComparator {
	bool operator() (Pismo& l, Pismo& r) {
		return l.prioritet < r.prioritet;
	}
};

int main() {
	priority_queue<Pismo, vector<Pismo>, LetterComparator> mailbox;

	mailbox.emplace("Primatelj 1", "Adresa 1", 4);
	mailbox.emplace("Primatelj 2", "Adresa 2", 2);
	mailbox.emplace("Primatelj 3", "Adresa 3", 1);
	mailbox.emplace("Primatelj 4", "Adresa 4", 3);
	mailbox.emplace("Primatelj 5", "Adresa 5", 5);

	while (!mailbox.empty()) {
		Pismo p = mailbox.top();
		p.print();
		cout << endl;

		mailbox.pop();
	}

	return 0;
}